
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>

#define isv(c) ((c)=='a' || (c)=='e' || (c)=='i' || (c)=='o' || (c)=='u')
#define isc(c) (!(isv(c)))
#define isdc(c) (isc(c) && c != 'n' && c != 'y' && c != 'x')
#define ishc(c) ((c) == 'x' || (c)=='z' || (c) == 'j' || (c) == 's')
#define isdi(p) (!(strnicmp(p, "nt", 2) & strnicmp(p, "ch", 2) & strnicmp(p, "th", 2) & strnicmp(p, "st", 2)))

int main(int argc, char **argv) {

        FILE *i, *o;
        char *b;
        int l, e, archaic = 0;

        if (argc < 3) {
                fprintf(stderr, " Correct call: dictpar.c <input> <output> {archaic inflections}\n");
                return -1;
        }

        if (4 == argc) {
                archaic = 1;
        }

        i = fopen(argv[1], "rb");
        o = fopen(argv[2], "w");

        l = filelength(fileno(i));
        b = (char *)malloc(l);

        fread(b, 1, l, i);

        for (e=0; e<l; ++e) {

                if (!strnicmp(b+e, "<b>", 3)) {
                        int beginw;
                        int lenw;
                        e += 3;
                        beginw = e;
                        while (b[e] != '<') {
                                b[e] = tolower(b[e]);
                                e++;
                        }
                        b[e] = 0;
                        lenw = strlen(b+beginw);
                        e += 3;
                        while (strnicmp(b+e, "<i>", 3)) {
                                e++;
                        }
                        e+=3;
                        /* now we are at the part of speech */

                        if (!strnicmp("n. pl.", b+e, 6) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("n.", b+e, 2) && !archaic) {

                                fprintf(o, "%s\n", b+beginw);

                                /* add plural as appropriate */

                                switch (b[beginw + lenw - 1]) {

                                        case 'y':
                                                b[beginw + lenw - 1] = 'i';
                                                fprintf(o, "%ses\n", b+beginw);
                                                break;

                                        case 'x':
                                        case 'z':
                                        case 'j':
                                                fprintf(o, "%ses\n", b+beginw);
                                                break;

                                        case 's':
                                                if (b[beginw + lenw - 2] == 'u') {
                                                        /* don't pluralize words ending in "us" */
                                                } else {
                                                        fprintf(o, "%ses\n", b+beginw);
                                                }
                                                break;

                                        case 'n':
                                                if (lenw >= 3 && !strcmp(b + beginw + lenw - 3, "man")) {
                                                        b[beginw + lenw - 2] = 'e';
                                                        fprintf(o, "%s\n", b+beginw);
                                                        break;
                                                }

                                        default:
                                                if (b[beginw + lenw - 1] == 'h' && (b[beginw + lenw - 2] == 'c' || b[beginw + lenw - 2] == 's')) {
                                                        fprintf(o, "%ses\n", b+beginw);
                                                } else {
                                                        fprintf(o, "%ss\n", b+beginw);
                                                }
                                                break;

                                }

                        } else if (!strnicmp("prep.", b+e, 5) && !archaic) {
                                /* don't write the word */
                        } else if (!strnicmp("pl.", b+e, 3) && !archaic) {
                                /* write as is */
                                fprintf(o, "%s\n", b+beginw);
                               
                        } else if (!strnicmp("a.", b+e, 2) && !archaic) {
                                /* write as is */
                                fprintf(o, "%s\n", b+beginw);
                        } else if (!strnicmp("v.", b+e, 2)) {

                                if (!archaic)
                                        fprintf(o, "%s\n", b+beginw);

                                /* inflect the verb properly */

                                if (isdc(b[beginw + lenw - 1]) && isv(b[beginw + lenw - 2]) && (lenw < 3 || !isv(b[beginw + lenw - 3]))) {
                                        // need to double the last letter

                                        if (!archaic)
                                                fprintf(o, "%s%ced\n", b+beginw, b[beginw + lenw - 1]);
                                        if (ishc(b[beginw + lenw - 1])) {
                                                if (!archaic)
                                                        fprintf(o, "%ses\n", b+beginw);
                                        } else {
                                                if (!archaic)
                                                        fprintf(o, "%ss\n", b+beginw);
                                        }
                                        fprintf(o, "%s%cing\n", b+beginw, b[beginw + lenw - 1]);
                                        if (archaic) {
                                                fprintf(o, "%s%ceth\n", b+beginw, b[beginw + lenw - 1]);
                                                fprintf(o, "%s%cest\n", b+beginw, b[beginw + lenw - 1]);
                                        }

                                } else {

                                        if (ishc(b[beginw + lenw - 1])) {
                                                if (!archaic)
                                                        fprintf(o, "%ses\n", b+beginw);
                                        } else {
                                                if (b[beginw + lenw - 1] == 'y') {
                                                        if (!archaic)
                                                                fprintf(o, "%sing\n", b+beginw);
                                                } else {
                                                        if (!archaic)
                                                                fprintf(o, "%ss\n", b+beginw);
                                                }
                                        }
                                        if (b[beginw + lenw - 1] != 'e') {
                                                if (b[beginw + lenw - 1] != 'y') {
                                                        if (archaic) {
                                                                fprintf(o, "%seth\n", b+beginw);
                                                                fprintf(o, "%sest\n", b+beginw);
                                                        } else {
                                                                fprintf(o, "%sed\n", b+beginw);
                                                                fprintf(o, "%sing\n", b+beginw);
                                                        }
                                                } else {
                                                        b[beginw + lenw - 1] = 'i';
                                                        if (!archaic) {
                                                                fprintf(o, "%ses\n", b+beginw);
                                                                fprintf(o, "%sed\n", b+beginw);
                                                        } else {
                                                                fprintf(o, "%seth\n", b+beginw);
                                                                fprintf(o, "%sest\n", b+beginw);
                                                        }
                                                }
                                        } else {
                                                if (!archaic)
                                                        fprintf(o, "%sd\n", b+beginw);
                                                if (archaic) {
                                                fprintf(o, "%sth\n", b+beginw);
                                                fprintf(o, "%sst\n", b+beginw);
                                                }
                                                if (!archaic) {
                                                b[beginw + lenw -1] = 'i';
                                                fprintf(o, "%sng\n", b+beginw);
                                                }
                                        }

                                }

#if 0
                                switch (b[beginw + lenw - 1]) {
/*
                                        case 't':

                                                if (b[beginw + lenw - 2] != 't') {

                                                fprintf(o, "%sted\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sting\n", b+beginw);
                                                fprintf(o, "%steth\n", b+beginw);
                                                fprintf(o, "%stest\n", b+beginw);
                                                inf = 1;
                                                break;

                                                }
                                                break;

                                        case 'g':

                                                if (b[beginw + lenw - 2] != 'g') {

                                                fprintf(o, "%sged\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sging\n", b+beginw);
                                                fprintf(o, "%sgeth\n", b+beginw);
                                                fprintf(o, "%sgest\n", b+beginw);
                                                inf = 1;
                                                break;

                                                }
                                                break;

                                        case 'b':

                                                if (b[beginw + lenw - 2] != 'b') {

                                                fprintf(o, "%sbed\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sbest\n", b+beginw);
                                                fprintf(o, "%sbeth\n", b+beginw);
                                                fprintf(o, "%sbing\n", b+beginw);
                                                inf = 1;
                                                break;

                                                }
                                                break;
*/

                                        case 'y':

                                                fprintf(o, "%sing\n", b+beginw);
                                                b[beginw + lenw - 1] = 'i';
                                                fprintf(o, "%sed\n", b+beginw);
                                                fprintf(o, "%ses\n", b+beginw);
                                                fprintf(o, "%sest\n", b+beginw);
                                                fprintf(o, "%seth\n", b+beginw);
                                                inf = 1;
                                                break;

                                        case 'e':

                                                fprintf(o, "%sd\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sth\n", b+beginw);
                                                fprintf(o, "%sst\n", b+beginw);
                                                b[beginw + lenw - 1] = 'i';
                                                fprintf(o, "%sng\n", b+beginw);
                                                inf = 1;
                                                break;

/*
                                        case 'd':

                                                if (b[beginw + lenw - 2] != 'd') {

                                                fprintf(o, "%sded\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sding\n", b+beginw);
                                                fprintf(o, "%sdeth\n", b+beginw);
                                                fprintf(o, "%sdest\n", b+beginw);
                                                inf = 1;
                                                break;

                                                }
                                                break;

                                        case 'f':

                                                if (b[beginw + lenw - 2] != 'f') {

                                                fprintf(o, "%sfed\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sfing\n", b+beginw);
                                                fprintf(o, "%sfeth\n", b+beginw);
                                                fprintf(o, "%sfest\n", b+beginw);
                                                inf = 1;
                                                break;

                                                }
                                                break;

                                        case 'j':

                                                if (b[beginw + lenw - 2] != 'j') {

                                                fprintf(o, "%sjed\n", b+beginw);
                                                fprintf(o, "%ss\n", b+beginw);
                                                fprintf(o, "%sjing\n", b+beginw);
                                                fprintf(o, "%sjeth\n", b+beginw);
                                                fprintf(o, "%sjest\n", b+beginw);
                                                        inf = 1;

                                                break;

                                                }
                                                break;

                                        case 'l':

                                                if (b[beginw + lenw - 2] != 'l') {

                                                        fprintf(o, "%sged\n", b+beginw);
                                                        fprintf(o, "%ss\n", b+beginw);
                                                        fprintf(o, "%sging\n", b+beginw);
                                                        fprintf(o, "%sgeth\n", b+beginw);
                                                        fprintf(o, "%sgest\n", b+beginw);
                                                        inf = 1;
                                                        break;

                                                }
                                                break;

                                        case 'm':

                                                if (b[beginw + lenw - 2] != 'm') {

                                                        fprintf(o, "%smed\n", b+beginw);
                                                        fprintf(o, "%ss\n", b+beginw);
                                                        fprintf(o, "%sming\n", b+beginw);
                                                        fprintf(o, "%smeth\n", b+beginw);
                                                        fprintf(o, "%smest\n", b+beginw);
                                                        inf = 1;
                                                        break;

                                                }

                                                break;
                                        case 'n':

                                                if (b[beginw + lenw - 2] != 'n') {

                                                        fprintf(o, "%sned\n", b+beginw);
                                                        fprintf(o, "%ss\n", b+beginw);
                                                        fprintf(o, "%sning\n", b+beginw);
                                                        fprintf(o, "%sneth\n", b+beginw);
                                                        fprintf(o, "%snest\n", b+beginw);
                                                        inf = 1;
                                                        break;

                                                }
                                                break;

                                        case 'p':

                                                if (b[beginw + lenw - 2] != 'p') {

                                                        fprintf(o, "%sped\n", b+beginw);
                                                        fprintf(o, "%ss\n", b+beginw);
                                                        fprintf(o, "%sping\n", b+beginw);
                                                        fprintf(o, "%speth\n", b+beginw);
                                                        fprintf(o, "%spest\n", b+beginw);
                                                        inf = 1;
                                                        break;

                                                }
                                                break;
*/
                                        case 'x':

                                                        fprintf(o, "%sed\n", b+beginw);
                                                        fprintf(o, "%ses\n", b+beginw);
                                                        fprintf(o, "%sing\n", b+beginw);
                                                        fprintf(o, "%seth\n", b+beginw);
                                                        fprintf(o, "%sest\n", b+beginw);
                                                        inf = 1;
                                                        break;
                                                break;

                                        case 'z':

                                                if (b[beginw + lenw - 2] != 'z') {

                                                        fprintf(o, "%szed\n", b+beginw);
                                                        fprintf(o, "%ses\n", b+beginw);
                                                        fprintf(o, "%szing\n", b+beginw);
                                                        fprintf(o, "%szeth\n", b+beginw);
                                                        fprintf(o, "%szest\n", b+beginw);
                                                        inf = 1;
                                                        break;

                                                }
                                                break;


                                }

                                if (!inf) {
                                                        fprintf(o, "%sed\n", b+beginw);
                                                        fprintf(o, "%ss\n", b+beginw);
                                                        fprintf(o, "%sing\n", b+beginw);
                                                        fprintf(o, "%seth\n", b+beginw);
                                                        fprintf(o, "%sest\n", b+beginw);
                                }

#endif

                        } else if (!strnicmp("imp.", b+e, 4) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("p.", b+e, 2) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("pron.", b+e, 5) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("adv.", b+e, 4) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("dat.", b +e, 4) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("interj.", b+e, 7) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        } else if (!strnicmp("superl.", b+e, 7) && !archaic) {
                                fprintf(o, "%s\n", b + beginw);
                        }

                }

        }

        free(b);

        return 0;

}
