
#include <iostream>
#include <fstream>

int main(int argc, char **argv) {

        char *prefixes[] = {
                "atto",
                "centi",
                "centimilli",
                "centimicro",
                "deca",         // synonym for deka- !
                "deci",
                "decimilli",
                "deka",
                "exa",
                "femto",
                "giga",
                "hecto",
                "hectokilo",
                "hectomega",
                "kilo",
                "mega",
                "micro",
                "milli",
                "myria",
                "nano",
                "peta",
                "pico",
                "tera",
                "yocto",        // really small
                "yotta",        // really big
                "zepto",
                "zeta",
        };
        
        const int npref = 27;   // 27 metric prefixes!

        if (argc < 3) {
                cerr << "Standard call: units [input] [output]\n";
                return -1;
        }

        ifstream i;
        ofstream o;

        int e;

        o.open(argv[2]);

        for (e=0; e<npref; ++e) {

                i.open(argv[1]);

                while (!i.eof()) {

                        char b[128];

                        i >> b;

                        // generate the prefixed unit names (singular and plural) and write to output

                        if (b[0]) {
                                if (b[strlen(b)-1] == 's' || b[strlen(b)-1] == 'x' || b[strlen(b)-1] == 'z') {
                                        o << prefixes[e] << b << endl;
                                        o << prefixes[e] << b << "es" << endl;
                                } else {
                                        o << prefixes[e] << b << endl;
                                        o << prefixes[e] << b << "s" << endl;
                                }
                        }

                }

                i.close();

        }

        o.close();

        return 0;


}

// end units.cxx
